## Description

This module uses twig to support SQL expressions for 
Views relationships. It can be applied selectively. 
It allows SQL joins that are not possible using the 
standard Views UI. This is done by providing the 
join condition as an SQL expression. 

This module depends upon the Views SQL Twig Fields module. 
Refer to that documentation for details abou the SQL
expression creation. 

## Warning, Please Read
This module provides access to SQL expressions within Views.
It should only be used by those who understand SQL.
It does provide access to features that would not be possible
such as aggregation of computed fields.

With great power comes great responsibility and care.
It is possible to mess up a view with expressions that
generate illegal syntax so backing up and making copies
of working views is a good idea.

Unlike Views in general, this module does not try to protect
you from bad syntax, etc. Please do not post questions
regarding SQL but do include those where SQL is not being
generated prooperly.

## REQUIREMENTS
This module requires:
* Views - part of the core
* Views-UI - part of the core
* Views SQL Twig Fields

## Permissions
There is a Twig SQL administration option that will prevent changes
to views that utilize Twig SQL components. It essentially turns all
the SQL fields to read-only mode. Users can view the settings but
cannot change them.

## Usage
1. Install the module in the usual way.
2. Add a relationship as usual and check the box for Twig SQL
   support and save it. You will need to edit is again to
   gain access to the Twig SQL settings. 
   The settings can be found in the Twig settings detail.
   The twig support is under the Twig definitions detail.
   The SQL expression is the one added to the Views query.

## How to use Twig SQL fields.
See the Views SQL Twig Fields documentation

## Tables, Variables and Substitutions
See the Views SQL Twig Fields documentation

## SQL Regeneration from Twig
See the Views SQL Twig Fields documentation

## Additional tokens
See the Views SQL Twig Fields documentation

## Debugging SQL
See the Views SQL Twig Fields documentation

## MAINTAINERS
Current maintainers:
* Bill Wong (bwong) - https://www.drupal.org/u/bwong

